Home | History | Annotate | Download | only in tests-m32
      1 #!/bin/sh
      2 #
      3 # Ensure that strace can detach from running processes.
      4 #
      5 # Copyright (c) 2013-2015 Dmitry V. Levin <ldv (at] altlinux.org>
      6 # All rights reserved.
      7 #
      8 # Redistribution and use in source and binary forms, with or without
      9 # modification, are permitted provided that the following conditions
     10 # are met:
     11 # 1. Redistributions of source code must retain the above copyright
     12 #    notice, this list of conditions and the following disclaimer.
     13 # 2. Redistributions in binary form must reproduce the above copyright
     14 #    notice, this list of conditions and the following disclaimer in the
     15 #    documentation and/or other materials provided with the distribution.
     16 # 3. The name of the author may not be used to endorse or promote products
     17 #    derived from this software without specific prior written permission.
     18 #
     19 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
     20 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
     21 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
     22 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
     23 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
     24 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     25 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     26 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     27 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
     28 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     29 
     30 . "${srcdir=.}/init.sh"
     31 
     32 run_prog_skip_if_failed \
     33 	kill -0 $$
     34 
     35 check_prog sleep
     36 
     37 set -e
     38 
     39 ./set_ptracer_any sh -c "echo > $LOG; while :; do :; done" > /dev/null &
     40 
     41 while ! [ -s "$LOG" ]; do
     42 	kill -0 $! 2> /dev/null ||
     43 		fail_ 'set_ptracer_any sh failed'
     44 	$SLEEP_A_BIT
     45 done
     46 
     47 tracee_pid=$!
     48 
     49 cleanup()
     50 {
     51 	set +e
     52 	kill $tracee_pid
     53 	wait $tracee_pid 2> /dev/null
     54 	return 0
     55 }
     56 
     57 rm -f "$LOG"
     58 $STRACE -p $tracee_pid 2> "$LOG" &
     59 
     60 while ! grep -F "Process $tracee_pid attached" "$LOG" > /dev/null; do
     61 	kill -0 $! 2> /dev/null || {
     62 		cleanup
     63 		dump_log_and_fail_with "$STRACE -p failed to attach"
     64 	}
     65 	$SLEEP_A_BIT
     66 done
     67 
     68 kill -INT $!
     69 wait $!
     70 
     71 grep -F "Process $tracee_pid detached" "$LOG" > /dev/null || {
     72 		cleanup
     73 		dump_log_and_fail_with "$STRACE -p failed to detach"
     74 	}
     75 
     76 if [ -f /proc/self/status ]; then
     77 	$SLEEP_A_BIT
     78 	test -d /proc/$tracee_pid || {
     79 		cleanup
     80 		dump_log_and_fail_with 'tracee died after detach'
     81 	}
     82 	grep_pid_status "$tracee_pid" '^State:.*R (running)' > /dev/null || {
     83 		grep_pid_status "$tracee_pid" '^State:'
     84 		cleanup
     85 		dump_log_and_fail_with 'tracee is not running after detach'
     86 	}
     87 fi
     88 
     89 cleanup
     90 exit 0
     91